import React, { MouseEvent } from 'react';
import { Node, NodeTypesType, SnapGrid } from '../../types';
interface NodeRendererProps {
    nodeTypes: NodeTypesType;
    selectNodesOnDrag: boolean;
    onNodeClick?: (event: MouseEvent, element: Node) => void;
    onNodeDoubleClick?: (event: MouseEvent, element: Node) => void;
    onNodeMouseEnter?: (event: MouseEvent, node: Node) => void;
    onNodeMouseMove?: (event: MouseEvent, node: Node) => void;
    onNodeMouseLeave?: (event: MouseEvent, node: Node) => void;
    onNodeContextMenu?: (event: MouseEvent, node: Node) => void;
    onNodeDragStart?: (event: MouseEvent, node: Node) => void;
    onNodeDrag?: (event: MouseEvent, node: Node) => void;
    onNodeDragStop?: (event: MouseEvent, node: Node) => void;
    onlyRenderVisibleElements: boolean;
}
interface NodesProps extends NodeRendererProps {
    nodes: Node[];
    isDraggable?: boolean;
    resizeObserver: ResizeObserver | null;
    scale: number;
    snapToGrid: boolean;
    snapGrid: SnapGrid;
    nodesDraggable: boolean;
    nodesConnectable: boolean;
    elementsSelectable: boolean;
    recursionDepth: number;
    parentId?: string;
}
interface NodeProps extends NodesProps {
    nodes: Node[];
    node: Node;
    nodeType: string;
}
declare function Node({ nodes, node, nodeType, isDraggable, resizeObserver, scale, snapToGrid, snapGrid, nodesDraggable, nodesConnectable, elementsSelectable, recursionDepth, ...props }: NodeProps): JSX.Element;
declare const _default: React.MemoExoticComponent<{
    (props: NodeRendererProps): JSX.Element;
    displayName: string;
}>;
export default _default;
