import { GetState } from 'zustand';
import { Node, Edge, Elements, Transform, XYPosition, Rect, Box, Connection, FlowExportObject, EdgeChange, NodeChange, ReactFlowState, EdgeMarkerType } from '../types';
export declare const isEdge: (element: Node | Connection | Edge) => element is Edge<any>;
export declare const isNode: (element: Node | Connection | Edge) => element is Node<any>;
export declare const getOutgoers: (node: Node, nodes: Node[], edges: Edge[]) => Node[];
export declare const getIncomers: (node: Node, nodes: Node[], edges: Edge[]) => Node[];
export declare const getMarkerId: (marker: EdgeMarkerType | undefined) => string;
export declare const addEdge: (edgeParams: Edge | Connection, edges: Edge[]) => Edge[];
export declare const updateEdge: (oldEdge: Edge, newConnection: Connection, elements: Elements<any>) => Elements<any>;
export declare const pointToRendererPoint: ({ x, y }: XYPosition, [tx, ty, tScale]: Transform, snapToGrid: boolean, [snapX, snapY]: [number, number]) => XYPosition;
export declare const onLoadProject: (getState: GetState<ReactFlowState>) => (position: XYPosition) => XYPosition;
export declare const rectToBox: ({ x, y, width, height }: Rect) => Box;
export declare const boxToRect: ({ x, y, x2, y2 }: Box) => Rect;
export declare const getBoundsofRects: (rect1: Rect, rect2: Rect) => Rect;
export declare const getRectOfNodes: (nodes: Node[]) => Rect;
export declare const graphPosToZoomedPos: ({ x, y }: XYPosition, [tx, ty, tScale]: Transform) => XYPosition;
export declare const getNodesInside: (nodes: Node[], rect: Rect, [tx, ty, tScale]?: Transform, partially?: boolean, excludeNonSelectableNodes?: boolean) => Node[];
export declare const getConnectedEdges: (nodes: Node[], edges: Edge[]) => Edge[];
export declare const onLoadGetNodes: (getState: GetState<ReactFlowState>) => () => Node[];
export declare const onLoadGetEdges: (getState: GetState<ReactFlowState>) => () => Edge[];
export declare const onLoadToObject: (getState: GetState<ReactFlowState>) => () => FlowExportObject;
export declare const getTransformForBounds: (bounds: Rect, width: number, height: number, minZoom: number, maxZoom: number, padding?: number) => Transform;
export declare function applyNodeChanges(changes: NodeChange[], nodes: Node[]): Node[];
export declare function applyEdgeChanges(changes: EdgeChange[], edges: Edge[]): Edge[];
